diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/qos-utils.h ns-3.34/src/wifi/model/qos-utils.h
--- ns-3.33/src/wifi/model/qos-utils.h	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/qos-utils.h	2021-07-14 10:31:07.000000000 -0700
@@ -22,12 +22,44 @@
 #define QOS_UTILS_H
 
 #include "ns3/ptr.h"
+#include <map>
 
 namespace ns3 {
 
 class Packet;
 class WifiMacHeader;
 class QueueItem;
+class Mac48Address;
+
+typedef std::pair<Mac48Address, uint8_t> WifiAddressTidPair;  //!< (MAC address, TID) pair
+
+/**
+ * Function object to compute the hash of a (MAC address, TID) pair
+ */
+struct WifiAddressTidHash
+{
+  /**
+   * Functional operator for (MAC address, TID) hash computation.
+   *
+   * \param addressTidPair the (MAC address, TID) pair
+   * \return the hash
+   */
+  std::size_t operator() (const WifiAddressTidPair& addressTidPair) const;
+};
+
+/**
+ * Function object to compute the hash of a MAC address
+ */
+struct WifiAddressHash
+{
+  /**
+   * Functional operator for MAC address hash computation.
+   *
+   * \param address the MAC address
+   * \return the hash
+   */
+  std::size_t operator() (const Mac48Address& address) const;
+};
 
 /**
  * \ingroup wifi
@@ -35,7 +67,7 @@
  * with values corresponding to the AC index (ACI) values specified
  * (Table 8-104 "ACI-to-AC coding"; IEEE 802.11-2012).
  */
-enum AcIndex
+enum AcIndex : uint8_t
 {
   /** Best Effort */
   AC_BE = 0,
@@ -52,6 +84,95 @@
 
 /**
  * \ingroup wifi
+ * This class stores the pair of TIDs of an Access Category.
+ */
+class WifiAc
+{
+public:
+  /**
+   * Constructor.
+   *
+   * \param lowTid the TID with lower priority
+   * \param highTid the TID with higher priority
+   */
+  WifiAc (uint8_t lowTid, uint8_t highTid);
+  /**
+   * Get the TID with lower priority
+   *
+   * \return the TID with lower priority
+   */
+  uint8_t GetLowTid (void) const;
+  /**
+   * Get the TID with higher priority
+   *
+   * \return the TID with higher priority
+   */
+  uint8_t GetHighTid (void) const;
+  /**
+   * Given a TID belonging to this Access Category, get the other TID of this AC.
+   *
+   * \param tid a TID belonging to this AC
+   * \return the other TID belonging to this AC
+   */
+  uint8_t GetOtherTid (uint8_t tid) const;
+
+private:
+  uint8_t m_lowTid;      //!< the TID with lower priority
+  uint8_t m_highTid;     //!< the TID with higher priority
+};
+
+/**
+ * \ingroup wifi
+ * Operator> overload returning true if the AC on the left has higher priority
+ * than the AC on the right.
+ *
+ * \param left the AC on the left of operator>
+ * \param right the AC on the right of operator>
+ * \return true if the AC on the left has higher priority than the AC on the right
+ */
+bool operator> (enum AcIndex left, enum AcIndex right);
+
+/**
+ * \ingroup wifi
+ * Operator>= overload returning true if the AC on the left has higher or the same
+ * priority than the AC on the right.
+ *
+ * \param left the AC on the left of operator>=
+ * \param right the AC on the right of operator>=
+ * \return true if the AC on the left has higher or the same priority than the AC on the right
+ */
+bool operator>= (enum AcIndex left, enum AcIndex right);
+
+/**
+ * \ingroup wifi
+ * Operator< overload returning true if the AC on the left has lower priority
+ * than the AC on the right.
+ *
+ * \param left the AC on the left of operator<
+ * \param right the AC on the right of operator<
+ * \return true if the AC on the left has lower priority than the AC on the right
+ */
+bool operator< (enum AcIndex left, enum AcIndex right);
+
+/**
+ * \ingroup wifi
+ * Operator<= overload returning true if the AC on the left has lower or the same
+ * priority than the AC on the right.
+ *
+ * \param left the AC on the left of operator<=
+ * \param right the AC on the right of operator<=
+ * \return true if the AC on the left has lower or the same priority than the AC on the right
+ */
+bool operator<= (enum AcIndex left, enum AcIndex right);
+
+/**
+ * Map containing the four ACs in increasing order of priority (according to
+ * Table 10-1 "UP-to-AC Mappings" of 802.11-2016)
+ */
+extern const std::map<AcIndex, WifiAc> wifiAcList;
+
+/**
+ * \ingroup wifi
  * Maps TID (Traffic ID) to Access classes.
  * For more details see (Table 9-1 "UP-to-AC mapping"; IEEE 802.11-2012).
  *
@@ -126,12 +247,11 @@
 
 /**
  * \ingroup wifi
- * Next function is useful to get traffic id of different packet types.
+ * This function is useful to get traffic id of different packet types.
  *
  * \param packet packet to check
  * \param hdr 802.11 header for packet to check
- *
- * Returns TID of different packet types
+ * \return the TID of different packet types
  */
 uint8_t GetTid (Ptr<const Packet> packet, const WifiMacHeader hdr);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/aarfcd-wifi-manager.cc ns-3.34/src/wifi/model/rate-control/aarfcd-wifi-manager.cc
--- ns-3.33/src/wifi/model/rate-control/aarfcd-wifi-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/aarfcd-wifi-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,421 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2004,2005,2006 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Federico Maguolo <maguolof@dei.unipd.it>
+ */
+
+#include "ns3/log.h"
+#include "ns3/packet.h"
+#include "aarfcd-wifi-manager.h"
+#include "ns3/wifi-tx-vector.h"
+
+#define Min(a,b) ((a < b) ? a : b)
+#define Max(a,b) ((a > b) ? a : b)
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("AarfcdWifiManager");
+
+/**
+ * \brief hold per-remote-station state for AARF-CD Wifi manager.
+ *
+ * This struct extends from WifiRemoteStation struct to hold additional
+ * information required by the AARF-CD Wifi manager
+ */
+struct AarfcdWifiRemoteStation : public WifiRemoteStation
+{
+  uint32_t m_timer; ///< timer
+  uint32_t m_success; ///< success
+  uint32_t m_failed; ///< failed
+  bool m_recovery; ///< recovery
+  bool m_justModifyRate; ///< just modify rate
+  uint32_t m_successThreshold; ///< success threshold
+  uint32_t m_timerTimeout; ///< timer timeout
+  uint8_t m_rate; ///< rate
+  bool m_rtsOn; ///< RTS on
+  uint32_t m_rtsWnd; ///< RTS window
+  uint32_t m_rtsCounter; ///< RTS counter
+  bool m_haveASuccess; ///< have a success
+};
+
+NS_OBJECT_ENSURE_REGISTERED (AarfcdWifiManager);
+
+TypeId
+AarfcdWifiManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::AarfcdWifiManager")
+    .SetParent<WifiRemoteStationManager> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<AarfcdWifiManager> ()
+    .AddAttribute ("SuccessK", "Multiplication factor for the success threshold in the AARF algorithm.",
+                   DoubleValue (2.0),
+                   MakeDoubleAccessor (&AarfcdWifiManager::m_successK),
+                   MakeDoubleChecker<double> ())
+    .AddAttribute ("TimerK",
+                   "Multiplication factor for the timer threshold in the AARF algorithm.",
+                   DoubleValue (2.0),
+                   MakeDoubleAccessor (&AarfcdWifiManager::m_timerK),
+                   MakeDoubleChecker<double> ())
+    .AddAttribute ("MaxSuccessThreshold",
+                   "Maximum value of the success threshold in the AARF algorithm.",
+                   UintegerValue (60),
+                   MakeUintegerAccessor (&AarfcdWifiManager::m_maxSuccessThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("MinTimerThreshold",
+                   "The minimum value for the 'timer' threshold in the AARF algorithm.",
+                   UintegerValue (15),
+                   MakeUintegerAccessor (&AarfcdWifiManager::m_minTimerThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("MinSuccessThreshold",
+                   "The minimum value for the success threshold in the AARF algorithm.",
+                   UintegerValue (10),
+                   MakeUintegerAccessor (&AarfcdWifiManager::m_minSuccessThreshold),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("MinRtsWnd",
+                   "Minimum value for RTS window of AARF-CD",
+                   UintegerValue (1),
+                   MakeUintegerAccessor (&AarfcdWifiManager::m_minRtsWnd),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("MaxRtsWnd",
+                   "Maximum value for RTS window of AARF-CD",
+                   UintegerValue (40),
+                   MakeUintegerAccessor (&AarfcdWifiManager::m_maxRtsWnd),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("TurnOffRtsAfterRateDecrease",
+                   "If true the RTS mechanism will be turned off when the rate will be decreased",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&AarfcdWifiManager::m_turnOffRtsAfterRateDecrease),
+                   MakeBooleanChecker ())
+    .AddAttribute ("TurnOnRtsAfterRateIncrease",
+                   "If true the RTS mechanism will be turned on when the rate will be increased",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&AarfcdWifiManager::m_turnOnRtsAfterRateIncrease),
+                   MakeBooleanChecker ())
+    .AddTraceSource ("Rate",
+                     "Traced value for rate changes (b/s)",
+                     MakeTraceSourceAccessor (&AarfcdWifiManager::m_currentRate),
+                     "ns3::TracedValueCallback::Uint64")
+  ;
+  return tid;
+}
+
+AarfcdWifiManager::AarfcdWifiManager ()
+  : WifiRemoteStationManager (),
+    m_currentRate (0)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+AarfcdWifiManager::~AarfcdWifiManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+AarfcdWifiManager::DoInitialize ()
+{
+  NS_LOG_FUNCTION (this);
+  if (GetHtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HT rates");
+    }
+  if (GetVhtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support VHT rates");
+    }
+  if (GetHeSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HE rates");
+    }
+}
+
+WifiRemoteStation *
+AarfcdWifiManager::DoCreateStation (void) const
+{
+  NS_LOG_FUNCTION (this);
+  AarfcdWifiRemoteStation *station = new AarfcdWifiRemoteStation ();
+
+  //AARF fields below
+  station->m_successThreshold = m_minSuccessThreshold;
+  station->m_timerTimeout = m_minTimerThreshold;
+  station->m_rate = 0;
+  station->m_success = 0;
+  station->m_failed = 0;
+  station->m_recovery = false;
+  station->m_timer = 0;
+
+  //AARF-CD specific fields below
+  station->m_rtsOn = false;
+  station->m_rtsWnd = m_minRtsWnd;
+  station->m_rtsCounter = 0;
+  station->m_justModifyRate = true;
+  station->m_haveASuccess = false;
+
+  return station;
+}
+
+void
+AarfcdWifiManager::DoReportRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+void
+AarfcdWifiManager::DoReportDataFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
+  station->m_timer++;
+  station->m_failed++;
+  station->m_success = 0;
+
+  if (!station->m_rtsOn)
+    {
+      TurnOnRts (station);
+      if (!station->m_justModifyRate && !station->m_haveASuccess)
+        {
+          IncreaseRtsWnd (station);
+        }
+      else
+        {
+          ResetRtsWnd (station);
+        }
+      station->m_rtsCounter = station->m_rtsWnd;
+      if (station->m_failed >= 2)
+        {
+          station->m_timer = 0;
+        }
+    }
+  else if (station->m_recovery)
+    {
+      NS_ASSERT (station->m_failed >= 1);
+      station->m_justModifyRate = false;
+      station->m_rtsCounter = station->m_rtsWnd;
+      if (station->m_failed == 1)
+        {
+          //need recovery fallback
+          if (m_turnOffRtsAfterRateDecrease)
+            {
+              TurnOffRts (station);
+            }
+          station->m_justModifyRate = true;
+          station->m_successThreshold = (int)(Min (station->m_successThreshold * m_successK,
+                                                   m_maxSuccessThreshold));
+          station->m_timerTimeout = (int)(Max (station->m_timerTimeout * m_timerK,
+                                               m_minSuccessThreshold));
+          if (station->m_rate != 0)
+            {
+              station->m_rate--;
+            }
+        }
+      station->m_timer = 0;
+    }
+  else
+    {
+      NS_ASSERT (station->m_failed >= 1);
+      station->m_justModifyRate = false;
+      station->m_rtsCounter = station->m_rtsWnd;
+      if (((station->m_failed - 1) % 2) == 1)
+        {
+          //need normal fallback
+          if (m_turnOffRtsAfterRateDecrease)
+            {
+              TurnOffRts (station);
+            }
+          station->m_justModifyRate = true;
+          station->m_timerTimeout = m_minTimerThreshold;
+          station->m_successThreshold = m_minSuccessThreshold;
+          if (station->m_rate != 0)
+            {
+              station->m_rate--;
+            }
+        }
+      if (station->m_failed >= 2)
+        {
+          station->m_timer = 0;
+        }
+    }
+  CheckRts (station);
+}
+
+void
+AarfcdWifiManager::DoReportRxOk (WifiRemoteStation *station,
+                                 double rxSnr, WifiMode txMode)
+{
+  NS_LOG_FUNCTION (this << station << rxSnr << txMode);
+}
+
+void
+AarfcdWifiManager::DoReportRtsOk (WifiRemoteStation *st,
+                                  double ctsSnr, WifiMode ctsMode, double rtsSnr)
+{
+  NS_LOG_FUNCTION (this << st << ctsSnr << ctsMode << rtsSnr);
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
+  NS_LOG_DEBUG ("station=" << station << " rts ok");
+  station->m_rtsCounter--;
+}
+
+void
+AarfcdWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                   double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
+{
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
+  station->m_timer++;
+  station->m_success++;
+  station->m_failed = 0;
+  station->m_recovery = false;
+  station->m_justModifyRate = false;
+  station->m_haveASuccess = true;
+  NS_LOG_DEBUG ("station=" << station << " data ok success=" << station->m_success << ", timer=" << station->m_timer);
+  if ((station->m_success == station->m_successThreshold
+       || station->m_timer == station->m_timerTimeout)
+      && (station->m_rate < (GetNSupported (station) - 1)))
+    {
+      NS_LOG_DEBUG ("station=" << station << " inc rate");
+      station->m_rate++;
+      station->m_timer = 0;
+      station->m_success = 0;
+      station->m_recovery = true;
+      station->m_justModifyRate = true;
+      if (m_turnOnRtsAfterRateIncrease)
+        {
+          TurnOnRts (station);
+          ResetRtsWnd (station);
+          station->m_rtsCounter = station->m_rtsWnd;
+        }
+    }
+  CheckRts (station);
+}
+
+void
+AarfcdWifiManager::DoReportFinalRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+void
+AarfcdWifiManager::DoReportFinalDataFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+WifiTxVector
+AarfcdWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  WifiMode mode = GetSupported (station, station->m_rate);
+  if (m_currentRate != mode.GetDataRate (channelWidth))
+    {
+      NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
+      m_currentRate = mode.GetDataRate (channelWidth);
+    }
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+}
+
+WifiTxVector
+AarfcdWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  /// \todo we could/should implement the AARF algorithm for
+  /// RTS only by picking a single rate within the BasicRateSet.
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  WifiTxVector rtsTxVector;
+  WifiMode mode;
+  if (GetUseNonErpProtection () == false)
+    {
+      mode = GetSupported (station, 0);
+    }
+  else
+    {
+      mode = GetNonErpSupported (station, 0);
+    }
+  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+  return rtsTxVector;
+}
+
+bool
+AarfcdWifiManager::DoNeedRts (WifiRemoteStation *st,
+                              uint32_t size, bool normally)
+{
+  NS_LOG_FUNCTION (this << st << size << normally);
+  AarfcdWifiRemoteStation *station = static_cast<AarfcdWifiRemoteStation*> (st);
+  NS_LOG_INFO ("" << station << " rate=" << station->m_rate << " rts=" << (station->m_rtsOn ? "RTS" : "BASIC") <<
+               " rtsCounter=" << station->m_rtsCounter);
+  return station->m_rtsOn;
+}
+
+void
+AarfcdWifiManager::CheckRts (AarfcdWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  if (station->m_rtsCounter == 0 && station->m_rtsOn)
+    {
+      TurnOffRts (station);
+    }
+}
+
+void
+AarfcdWifiManager::TurnOffRts (AarfcdWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  station->m_rtsOn = false;
+  station->m_haveASuccess = false;
+}
+
+void
+AarfcdWifiManager::TurnOnRts (AarfcdWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  station->m_rtsOn = true;
+}
+
+void
+AarfcdWifiManager::IncreaseRtsWnd (AarfcdWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  if (station->m_rtsWnd == m_maxRtsWnd)
+    {
+      return;
+    }
+
+  station->m_rtsWnd *= 2;
+  if (station->m_rtsWnd > m_maxRtsWnd)
+    {
+      station->m_rtsWnd = m_maxRtsWnd;
+    }
+}
+
+void
+AarfcdWifiManager::ResetRtsWnd (AarfcdWifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+  station->m_rtsWnd = m_minRtsWnd;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/aarfcd-wifi-manager.h ns-3.34/src/wifi/model/rate-control/aarfcd-wifi-manager.h
--- ns-3.33/src/wifi/model/rate-control/aarfcd-wifi-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/aarfcd-wifi-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,135 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2005,2006 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Federico Maguolo <maguolof@dei.unipd.it>
+ */
+
+#ifndef AARFCD_WIFI_MANAGER_H
+#define AARFCD_WIFI_MANAGER_H
+
+#include "ns3/traced-value.h"
+#include "ns3/wifi-remote-station-manager.h"
+
+namespace ns3 {
+
+struct AarfcdWifiRemoteStation;
+
+/**
+ * \brief an implementation of the AARF-CD algorithm
+ * \ingroup wifi
+ *
+ * This algorithm was first described in "Efficient Collision Detection for Auto Rate Fallback Algorithm".
+ * The implementation available here was done by Federico Maguolo for a very early development
+ * version of ns-3. Federico died before merging this work in ns-3 itself so his code was ported
+ * to ns-3 later without his supervision.
+ *
+ * This RAA does not support HT modes and will error
+ * exit if the user tries to configure this RAA with a Wi-Fi MAC
+ * that supports 802.11n or higher.
+ */
+class AarfcdWifiManager : public WifiRemoteStationManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  AarfcdWifiManager ();
+  virtual ~AarfcdWifiManager ();
+
+
+private:
+  void DoInitialize (void) override;
+  WifiRemoteStation * DoCreateStation (void) const override;
+  void DoReportRxOk (WifiRemoteStation *station,
+                     double rxSnr, WifiMode txMode) override;
+
+  void DoReportRtsFailed (WifiRemoteStation *station) override;
+  /**
+   * It is important to realize that "recovery" mode starts after failure of
+   * the first transmission after a rate increase and ends at the first successful
+   * transmission. Specifically, recovery mode transcends retransmissions boundaries.
+   * Fundamentally, ARF handles each data transmission independently, whether it
+   * is the initial transmission of a packet or the retransmission of a packet.
+   * The fundamental reason for this is that there is a backoff between each data
+   * transmission, be it an initial transmission or a retransmission.
+   *
+   * \param station the station that we failed to send Data
+   */
+  void DoReportDataFailed (WifiRemoteStation *station) override;
+  void DoReportRtsOk (WifiRemoteStation *station,
+                      double ctsSnr, WifiMode ctsMode, double rtsSnr) override;
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss) override;
+  void DoReportFinalRtsFailed (WifiRemoteStation *station) override;
+  void DoReportFinalDataFailed (WifiRemoteStation *station) override;
+  WifiTxVector DoGetDataTxVector (WifiRemoteStation *station) override;
+  WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station) override;
+  bool DoNeedRts (WifiRemoteStation *station,
+                  uint32_t size, bool normally) override;
+
+  /**
+   * Check if the use of RTS for the given station can be turned off.
+   *
+   * \param station the station that we are checking
+   */
+  void CheckRts (AarfcdWifiRemoteStation *station);
+  /**
+   * Increase the RTS window size of the given station.
+   *
+   * \param station the station to increase RTS window
+   */
+  void IncreaseRtsWnd (AarfcdWifiRemoteStation *station);
+  /**
+   * Reset the RTS window of the given station.
+   *
+   * \param station the station to reset RTS window
+   */
+  void ResetRtsWnd (AarfcdWifiRemoteStation *station);
+  /**
+   * Turn off RTS for the given station.
+   *
+   * \param station the station to turn RTS off
+   */
+  void TurnOffRts (AarfcdWifiRemoteStation *station);
+  /**
+   * Turn on RTS for the given station.
+   *
+   * \param station the station to turn RTS on
+   */
+  void TurnOnRts (AarfcdWifiRemoteStation *station);
+
+  //AARF fields below
+  uint32_t m_minTimerThreshold;   ///< minimum timer threshold
+  uint32_t m_minSuccessThreshold; ///< minimum success threshold
+  double m_successK;              ///< Multiplication factor for the success threshold
+  uint32_t m_maxSuccessThreshold; ///< maximum success threshold
+  double m_timerK;                ///< Multiplication factor for the timer threshold
+
+  //AARF-CD fields below
+  uint32_t m_minRtsWnd;               ///< minimum RTS window
+  uint32_t m_maxRtsWnd;               ///< maximum RTS window
+  bool m_turnOffRtsAfterRateDecrease; ///< turn off RTS after rate decrease
+  bool m_turnOnRtsAfterRateIncrease;  ///< turn on RTS after rate increase
+
+  TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
+};
+
+} //namespace ns3
+
+#endif /* AARFCD_WIFI_MANAGER_H */
